! read density in e/au^3 from ".xsf" format file (XCrysDen)
! then write the binary file needed by InteGriTy
!
  program main

      integer(4)              ::  i,j,k,np1,np2,np3,ii,jj,kk,nn,jf,nfile
      real(8)                 ::  ao,ao3,rhomin,rhomax,q,dv,a,b,c,r
      real(8),dimension(3)    ::  origin,del1,del2,del3,w,ww
      real(8),allocatable     ::  rho(:,:,:)
      character(256)          ::  tutu, file_name
      character(100)          ::  pth 
      character(100), allocatable ::fname(:)
      character(56)           ::  ext
      character(1)            ::  qt
      character(5)            ::  atom
!      
!
      ao=0.529177
      ao3=ao*ao*ao
      rhomin=1.0d10
      rhomax=0.0d10
      qt=char(39)
!
!     input filename of ".xsf" density file,  including pathway

      open(unit=20, file='xsf2integrity.in')
      read(20,'(a)') pth
      read(20,'(i4)')nfile
      write(*,'(a,i2)')'Number of data files: ',nfile
      allocate(fname(nfile))
      do jf=1,nfile
        read(20,'(a)') fname(jf)
        write(*,'(a,i2,a,a)')'file #', jf, ' : ',fname(jf)
      enddo
      close(20)
      
!    
    do  jf=1,nfile
      ext='.xsf'
      file_name=trim(pth)//trim(fname(jf))//trim(ext)
      open(unit=10,file=trim(file_name))
        write(*,'(//,a)') 'open  '//file_name
      do
         read(10,*)tutu
         if (index(tutu,'PRIMCOORD').ne.0) exit
      enddo
      read(10,*)nn
      write(*,'(a,i4)')' nb of atoms :',nn
      ext='.in'
      file_name=trim(pth)//trim(fname(jf))//trim(ext)
      open(unit=11,file=file_name)
      write(*,'(a)') ' Write InteGriTy like atoms'' input file'
      write(*,'(10x,a)') trim(file_name)
      write(11,'(a)')trim(fname(jf))
      write(11,*)1.D0
      do i=1,nn
       read(10,*)j,w(:)
       call label_atom(j,i,atom,r)
        write(11,'(5a,3f12.5,a,f4.2,a)')'!ATOM   NAME=',qt,trim(atom),qt,'  R= ', w(:)/ao, '   RMIN=',r,'  MOL=1   !END'
        write(*,'(i2,a6,a2,3f12.5)')i,trim(atom),' :', w(:)/ao
      enddo
      write(11,*)'!EOB'
      close(11)
!
      do
         read(10,*)tutu
!!!         write(*,*)trim(tutu)
         if (index(tutu,'DATAGRID_3D').ne.0) exit
      enddo
      read(10,*)n1,n2,n3
      read(10,*)origin(:)
      read(10,*)del1(:)
      read(10,*)del2(:)
      read(10,*)del3(:)
!      
!
      origin=origin/ao
      del1=del1/ao
      del2=del2/ao
      del3=del3/ao
      a=dsqrt(dot_product(del1,del1))
      b=dsqrt(dot_product(del2,del2))
      c=dsqrt(dot_product(del3,del3))
      del1(:)=del1(:)/dble(n1-1)
      del2(:)=del2(:)/dble(n2-1)
      del3(:)=del3(:)/dble(n3-1)
      call cross_product(del1,del2,ww)
      dv=dot_product(del3,ww)
      allocate(rho(n1,n2,n3))
      write(*,'(a,f12.5)')' Cell Volume :', dble((n1-1)*(n2-1)*(n3-1))*dv
      
      write(*,'(//,a)')' Read rho, be patient ...'
      read(10,*)rho(:,:,:)
      write(*,'(a,f12.5)')' Sum rho     :', sum(rho(1:(n1-1),1:(n2-1),1:(n3-1)))*dv
      close(10)
     

      ext='.data'
      file_name=trim(pth)//trim(fname(jf))//trim(ext)
      open(unit=11,file=file_name,form='unformatted')     
      write(11)n1-1,n2-1,n3-1
      write(11)origin
      write(11)del1
      write(11)del2
      write(11)del3
      write(*,'(a,3i4)')    ' Nb mesh : ',n1-1,n2-1,n3-1
      write(*,'(a,3f10.4)') ' Origin  : ',origin
      write(*,'(a,3f10.4)') ' del1    = ',del1
      write(*,'(a,3f10.4)') ' del2    = ',del2
      write(*,'(a,3f10.4)') ' del3    = ',del3
      write(*,'(a,f8.4,3x,a,f8.4,3x,a,f8.4)')'a=',a,'b=',b,'c=',c 
      write(*,'(//,a)')'write rho'
      write(11) &
     &     (((rho(i,j,k) &
     &                ,k=1,n3-1) &
     &                ,j=1,n2-1) &
     &                ,i=1,n1-1)
!
      close(11)
      !!
      deallocate(rho)
      
   end do
      deallocate(fname)
      write(*,*)'job done'

   end program main
!
!---------------------------------------------------------------------------------------------
!     
 subroutine cross_product(a,b,c)
 !
  real(8), dimension(3) ::a,b,c
 !
  c(1)=a(2)*b(3)-b(2)*a(3) 
  c(2)=a(3)*b(1)-b(3)*a(1)
  c(3)=a(1)*b(2)-b(1)*a(2)
 !
 end subroutine cross_product
 !---------------------------------------------------------------------------------------------
!     
 subroutine label_atom(n,i,a,r)
 !
  real(8)            ::r
  integer(4)         ::n,i,nc,nd,nu
  character(5)       ::a
  character(2)       ::s
  character(1)       ::sc,sd,su
 !
  select case(n)
   case(1)
      s='H_'
      r=0.45
   case(6)
      s='C_'
      r=0.5
   case(7)
      s='N_'
      r=0.6
   case(8)
      s='O_'
      r=0.8
   case(9)
      s='F_'
      r=0.8
   case(14)
      s='Si'
      r=1.2
   case(15)
      s='P_'
      r=0.8
   case(16)
      s='S_'
      r=0.8
   case(17)
      s='Cl'
      r=1.2
   case(31)
      s='Ga'
      r=1.2
   case(32)
      s='Ge'
      r=1.2
   case(33)
      s='As'
      r=1.2
   case(39)
      s='Y_'
   case(56)
      s='Ba'
      r=1.2
   case(57)
      s='La'
      r=1.2
   case(66)
      s='Dy'
      r=1.2
   case(68)
      s='Er'
      r=1.2
   case default
      write(*,'(a,i3,a)')' Atom with ', n,'electrons is unknown. Modify subroutineroutine'
      write(*,'(a)')' Please modify subroutine "label_atom" in "xsf2integrity.f90" !!!'
      s='C_'
      r=0.5
   end select   
  !
    nc=i/100
    nd=(i-100*nc)/10
    nu=(i-100*nc-10*nd)
  !
    if (nc.eq.0) then
       sc=''
    else
       sc=char(nc+48)
    endif
    if (nd.eq.0 .and. nc.eq.0) then
       sd=''
    else
       sd=char(nd+48)
    endif
    if (nu.eq.0 .and. nd.eq.0 .and. nc.eq.0) then
       su=''
    else
       su=char(nu+48)
    endif
    a=s//trim(sc)//trim(sd)//trim(su)
!
   end subroutine label_atom
